<?php

namespace FiloBlu\Cegid\Model;


use FiloBlu\Cegid\Api\Data\SellerQuoteInterface;
use FiloBlu\Cegid\Api\SellerQuoteRepositoryInterface;
use FiloBlu\Cegid\Api\Data\SellerQuoteInterfaceFactory;
use Magento\Framework\App\ResourceConnection;

/**
 * Class SellerQuoteRepository
 * @package FiloBlu\Cegid\Model
 */
class SellerQuoteRepository implements SellerQuoteRepositoryInterface
{

    /**
     * @var ResourceConnection
     */
    protected $resourceConnection;
    /**
     * @var SellerQuoteInterfaceFactory
     */
    private $sellerQuoteFactory;

    /**
     * SellerRepository constructor.
     * @param ResourceConnection $resourceConnection
     * @param SellerQuoteInterfaceFactory $sellerQuoteFactory
     */
    public function __construct(ResourceConnection $resourceConnection, SellerQuoteInterfaceFactory $sellerQuoteFactory)
    {
        $this->resourceConnection = $resourceConnection;
        $this->sellerQuoteFactory = $sellerQuoteFactory;
    }

    /**
     * @param $id
     * @return SellerQuoteInterface
     */
    public function get($id)
    {
        return $this->sellerQuoteFactory->create();
    }

    /**
     * @param SellerQuoteInterface $seller
     * @return mixed
     */
    public function save(SellerQuoteInterface $seller)
    {
        $connection = $this->resourceConnection->getConnection();
        $table = $connection->getTableName('filoblu_cegid_quote_extension');
        $connection->insertOnDuplicate($table, ['quote_id' => $seller->getQuote(), 'seller_id' => $seller->getSeller()], ['seller_id']);
    }
}